/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */
var ContextMenuEvent,__decorate=function(e,t,n,o){var i,s=arguments.length,r=s<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,n):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,o);else for(var a=e.length-1;a>=0;a--)(i=e[a])&&(r=(s<3?i(r):s>3?i(t,n,r):i(t,n))||r);return s>3&&r&&Object.defineProperty(t,n,r),r};import{AjaxResponse}from"@typo3/core/ajax/ajax-response.js";import AjaxRequest from"@typo3/core/ajax/ajax-request.js";import ContextMenuActions from"@typo3/backend/context-menu-actions.js";import"@typo3/backend/element/spinner-element.js";import{customElement,queryAll,state}from"lit/decorators.js";import{html,LitElement,nothing}from"lit";import{delay}from"@typo3/core/lit-helper.js";import{styleMap}from"lit/directives/style-map.js";import{unsafeHTML}from"lit/directives/unsafe-html.js";import{Task,initialState}from"@lit/task";import Notification from"@typo3/backend/notification.js";!function(e){e.open="typo3:contextmenu:open",e.close="typo3:contextmenu:close"}(ContextMenuEvent||(ContextMenuEvent={}));class ContextMenu{constructor(){document.addEventListener("click",(e=>{this.handleTriggerEvent(e)})),document.addEventListener("contextmenu",(e=>{this.handleTriggerEvent(e)}))}show(e,t,n,o,i,s=null,r=null){const a=new CustomEvent(ContextMenuEvent.open,{detail:{table:e,uid:t,context:n,eventSource:s,originalEvent:r},bubbles:!0,composed:!0});top.document.dispatchEvent(a)}handleTriggerEvent(e){if(!(e.target instanceof Element))return;const t=e.target.closest("[data-contextmenu-trigger]");t instanceof HTMLElement&&this.handleContextMenuEvent(e,t)}handleContextMenuEvent(e,t){const n=t.dataset.contextmenuTrigger;"click"!==n&&n!==e.type||(e.preventDefault(),this.show(t.dataset.contextmenuTable??"",t.dataset.contextmenuUid??"",t.dataset.contextmenuContext??"","","",t,e))}}export default new ContextMenu;let ContextMenuElement=class extends LitElement{constructor(){super(...arguments),this.open=!1,this.table="",this.uid="",this.context="",this.rootPositionY=0,this.rootPositionX=0,this.eventSource=null,this.rootIdentifier="root",this.focusFirstElement=!1,this.fetchTask=new Task(this,{autoRun:!1,args:()=>[this.table,this.uid,this.context,this.open],task:async([e,t,n,o],{signal:i})=>{if(!o)return initialState;const s=new URLSearchParams;if(""!==e&&s.set("table",e),""!==t&&s.set("uid",t.toString()),""!==n&&s.set("context",n),0===s.size)return initialState;const r=TYPO3.settings.ajaxUrls.contextmenu,a=await new AjaxRequest(r).withQueryArguments(s).get({signal:i}),c=Object.values(await a.resolve());return 0===c.length?initialState:this.enhanceNodes("root",c)},onComplete:()=>{this.focusFirstElement=!0},onError:e=>{e instanceof AjaxResponse?Notification.error("",e.response.status+" "+e.response.statusText,5):Notification.error("",e.message)}}),this.show=e=>{const t=e.detail;if(this.open=!0,this.table=t.table,this.uid=t.uid,this.context=t.context,this.eventSource=t.eventSource,null!==t.originalEvent){const e=this.calculateIframeOffset(t.originalEvent.view,window);this.rootPositionY=t.originalEvent.clientY+e.y,this.rootPositionX=t.originalEvent.clientX+e.x}this.fetchTask.run()},this.hide=async()=>{this.open&&(this.open=!1,this.fetchTask.run(),await this.updateComplete,this.eventSource?.focus())}}get nodes(){return this.fetchTask.value??[]}connectedCallback(){super.connectedCallback(),window.addEventListener("resize",this.hide),document.addEventListener(ContextMenuEvent.open,this.show),document.addEventListener(ContextMenuEvent.close,this.hide)}disconnectedCallback(){super.disconnectedCallback(),window.removeEventListener("resize",this.hide),document.removeEventListener(ContextMenuEvent.open,this.show),document.removeEventListener(ContextMenuEvent.close,this.hide)}updated(){if(this.focusFirstElement){if(this.contextMenuItemElements.length>0){Array.from(this.contextMenuItemElements).at(0).focus()}this.focusFirstElement=!1}this.updateContextMenuPositions()}createRenderRoot(){return this}render(){return this.fetchTask.render({initial:()=>nothing,pending:()=>[this.renderOverlay(),delay(80,(()=>this.renderMenu(null,this.rootIdentifier,this.rootPositionY,this.rootPositionX)))],complete:e=>[this.renderOverlay(),this.renderMenu(e,this.rootIdentifier,this.rootPositionY,this.rootPositionX),this.flattenMenuItems(e).filter((e=>"submenu"===e.type)).map((e=>this.isNodeExpanded(e)?this.renderMenu(e.childItems,this.getNodeIdentifier(e),this.rootPositionY,this.rootPositionX):nothing))]})}renderOverlay(){return html`<div class="context-menu-overlay" @click="${e=>this.handleOverlayClick(e)}" @contextmenu="${e=>this.handleOverlayClick(e)}"></div>`}renderMenu(e,t,n,o){const i={top:n+"px",insetInlineStart:o+"px"};return null===e?html`<div id="contextmenu-${t}" data-contextmenu-parent="${t}" class="context-menu" style="${styleMap(i)}"><typo3-backend-spinner size="medium"></typo3-backend-spinner></div>`:0===e.length?nothing:html`<div id="contextmenu-${t}" data-contextmenu-parent="${t}" class="context-menu" style="${styleMap(i)}"><ul class="context-menu-group" role="menu">${e.map((e=>html`<li role="presentation">${this.renderMenuItem(e)}</li>`))}</ul></div>`}renderMenuItem(e){return"divider"===e.type?html`<hr class="context-menu-divider">`:html`<button type="button" class="context-menu-item" tabindex="-1" role="menuitem" data-contextmenu-id="${this.getNodeIdentifier(e)}" data-contextmenu-type="${e.type}" aria-posinset="${this.getNodePositionInSet(e)}" aria-setsize="${this.getNodeSetSize(e)}" aria-label="${e.label}" aria-popup="${"submenu"===e.type?"menu":nothing}" @click="${t=>{this.handleNodeClick(t,e)}}" @keydown="${t=>{this.handleNodeKeyDown(t,e)}}"><span class="context-menu-item-icon" role="presentation">${unsafeHTML(e.icon)}</span> <span class="context-menu-item-label" role="presentation">${unsafeHTML(e.label)}</span> ${"submenu"===e.type?html`<span class="context-menu-item-indicator"><typo3-backend-icon identifier="actions-chevron-${"ltr"===this.getDocumentDirection()?"right":"left"}" size="small"></typo3-backend-icon></span>`:""}</button>`}showSubmenu(e){e.__expanded=!0}hideSubmenu(e){e.__expanded=!1}handleNodeClick(e,t){if("submenu"===t.type)return void(this.isNodeExpanded(t)?this.hideSubmenu(t):this.showSubmenu(t));const n=this.extractDataAttributesAndConvertToDataset(t.additionalAttributes),o=t.callbackAction,{callbackModule:i,...s}=n;i?import(i+".js").then((({default:e})=>{e[o](this.table,this.uid,s)})):ContextMenuActions&&"function"==typeof ContextMenuActions[o]?ContextMenuActions[o](this.table,this.uid,s):console.error("action: "+o+" not found"),this.hide()}mapIframeTarget(e,t){if("IFRAME"!==e.tagName)return e;const n=e;let o;try{o=n.contentWindow}catch{return e}const i=n.getBoundingClientRect();return o.document.elementFromPoint(t.clientX-i.x,t.clientY-i.y)??e}async handleOverlayClick(e){e.preventDefault(),e.stopPropagation(),this.eventSource=null,await this.hide();let t=document.elementFromPoint(e.clientX,e.clientY);t&&t!==e.currentTarget&&(t=this.mapIframeTarget(t,e),t.dispatchEvent(new PointerEvent(e.type,e)),"INPUT"!==t.tagName&&"TEXTAREA"!==t.tagName||t.focus())}async handleNodeKeyDown(e,t){if(!["ArrowDown","ArrowUp","ArrowLeft","ArrowRight","Home","End","Enter","Space","Escape","Tab"].includes(e.code)||e.altKey||e.ctrlKey)return;e.preventDefault(),e.stopPropagation();const n=this.getParralellNodesForNavigation(t),o=this.getFirstNode(n),i=this.getLastNode(n),s=this.getParentNode(t),r=this.getPreviousNode(t),a=this.getNextNode(t);switch(e.code){case"Enter":case"Space":if("submenu"===t.type){this.showSubmenu(t),await this.updateComplete;const e=this.getFirstNode(t.childItems);e&&this.getElementFromNode(e)?.focus()}else this.getElementFromNode(t)?.click();break;case"Tab":this.hide();break;case"Escape":s?(this.hideSubmenu(s),await this.updateComplete,this.getElementFromNode(s)?.focus()):this.hide();break;case"ArrowUp":r&&this.getElementFromNode(r)?.focus();break;case"ArrowDown":a&&this.getElementFromNode(a)?.focus();break;case"ArrowRight":if("submenu"===t.type){this.showSubmenu(t),await this.updateComplete;const e=this.getFirstNode(t.childItems);e&&this.getElementFromNode(e)?.focus()}break;case"ArrowLeft":s&&(this.hideSubmenu(s),await this.updateComplete,this.getElementFromNode(s)?.focus());break;case"Home":this.getElementFromNode(o)?.focus();break;case"End":this.getElementFromNode(i)?.focus();break;default:return}}getNodeIdentifier(e){return e.__contextMenuIdentifier}getNodeParentIdentifier(e){return e.__contextMenuParentIdentifier}getNodePositionInSet(e){return this.getParralellNodesForNavigation(e).indexOf(e)+1}getNodeSetSize(e){return this.getParralellNodesForNavigation(e).length}getParentNode(e){const t=this.getNodeParentIdentifier(e);return this.getNodeByIdentifier(t)}getNodeByIdentifier(e){return this.flattenMenuItems(this.nodes).find((t=>this.getNodeIdentifier(t)===e))??null}getPreviousNode(e){const t=this.getParralellNodesForNavigation(e),n=t.indexOf(e)-1;return t[n]?t[n]:this.getLastNode(t)}getNextNode(e){const t=this.getParralellNodesForNavigation(e),n=t.indexOf(e)+1;return t[n]?t[n]:this.getFirstNode(t)}getFirstNode(e){return e.at(0)??null}getLastNode(e){return e.at(-1)??null}isNodeExpanded(e){return!0===e.__expanded}getElementFromNode(e){return this.querySelector('[data-contextmenu-id="'+this.getNodeIdentifier(e)+'"]')}enhanceNodes(e,t){return t.reduce(((t,n)=>{const o=e+"_"+n.identifier,i={...n,__contextMenuIdentifier:o,__contextMenuParentIdentifier:e,__expanded:!1,childItems:this.enhanceNodes(o,Object.values(n.childItems??{}))},s=this;return[...t,new Proxy(i,{set:(e,t,n)=>(e[t]!==n&&(e[t]=n,s.requestUpdate()),!0)})]}),[])}calculateIframeOffset(e,t){let n=0,o=0;if(e===t)return{x:n,y:o};const i=this.calculateIframeOffset(e.parent,t);n+=i.x,o+=i.y;const s=e.frameElement;if(s){const e=s.getBoundingClientRect();n+=e.x,o+=e.y}return{x:n,y:o}}extractDataAttributesAndConvertToDataset(e){const t=e=>e.replace(/^data-/,"").replace(/-([a-z])/g,((e,t)=>t.toUpperCase()));return Object.fromEntries(Object.entries(e).filter((([e])=>e.startsWith("data-"))).map((([e,n])=>[t(e),String(n)])))}updateContextMenuPositions(){if(this.contextMenuElements.length>0){const e=this.contextMenuElements[0];this.updateContextMenuPosition(e,this.rootPositionY,this.rootPositionX);const t=[...this.contextMenuElements].slice(1),n=this.getDocumentDirection();t.forEach((e=>{const t=this.getNodeByIdentifier(e.dataset.contextmenuParent),o=this.getElementFromNode(t).getBoundingClientRect(),i=o.top-7,s="ltr"===n?o.right:o.left;this.updateContextMenuPosition(e,i,s)}))}}updateContextMenuPosition(e,t,n){const o=this.getDocumentDirection(),i=e.offsetWidth,s=e.offsetHeight,r=document.documentElement.clientWidth,a=document.documentElement.clientHeight;let c=0,l=0;l=t,c="ltr"===o?n:r-n;l+s+10+5<a?l+=5:l=a-s-10,c+i+10+5<r?c+=5:c=r-i-10,e.style.top=Math.round(l)+"px",e.style.insetInlineStart=Math.round(c)+"px"}flattenMenuItems(e){const t=[];for(const n of e)t.push(n),n.childItems&&t.push(...this.flattenMenuItems(n.childItems));return t}getParralellNodesForNavigation(e){const t=this.getParentNode(e);return t?t.childItems.filter((e=>"divider"!==e.type)):this.nodes.filter((e=>"divider"!==e.type))}getDocumentDirection(){return"rtl"===document.querySelector("html").dir?"rtl":"ltr"}};__decorate([state()],ContextMenuElement.prototype,"open",void 0),__decorate([state()],ContextMenuElement.prototype,"table",void 0),__decorate([state()],ContextMenuElement.prototype,"uid",void 0),__decorate([state()],ContextMenuElement.prototype,"context",void 0),__decorate([state()],ContextMenuElement.prototype,"rootPositionY",void 0),__decorate([state()],ContextMenuElement.prototype,"rootPositionX",void 0),__decorate([state()],ContextMenuElement.prototype,"eventSource",void 0),__decorate([queryAll(".context-menu")],ContextMenuElement.prototype,"contextMenuElements",void 0),__decorate([queryAll(".context-menu-item")],ContextMenuElement.prototype,"contextMenuItemElements",void 0),ContextMenuElement=__decorate([customElement("typo3-backend-context-menu")],ContextMenuElement);export{ContextMenuElement};